/*
* This file is part of the Tecodino-Sensor-Project.
* Even if you can use Tecodino with GR-16 and GR-12
* the software has nothing to do with Graupner(R)!
*
* Copyright(c) Stefan Radolf, 2011
*
* This file may be licensed under the terms of of the
* GNU Lesser General Public License Version 3 (the ``LGPL''),
* or (at your option) any later version.
*
* Software distributed under the License is distributed
* on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
* express or implied. See the LGPL for the specific language
* governing rights and limitations.
*
* You should have received a copy of the LGPL along with this
* program. If not, go to http://www.gnu.org/licenses/lgpl.html
* or write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

//#include <Wire.h>
#include <WProgram.h> 

#ifndef GMessage_H
#define GMessage_H 

#define VERSION_STRING Version 0204 autor: flying-doctor

#define MESSAGE_STARTBYTE_POS	         3
#define MESSAGE_ENDBYTE_POS		33
#define MESSAGE_CHECKBYTE_POS	        35
#define LENGTH				36
#define PROZESSOR_GESCHWINDIGKEITS_TYP	2

#define MESSAGE_ALARMBYTE_POS 0x03
#define ALARM_LOW_VOLTAGE 0x10
#define ALARM_OFF 0x00
//max and min values for high- and low-voltage-alarm
#define MAX_VOLT_1_CELL_LIPO 4.3
#define MIN_VOLT_1_CELL_LIPO 3.4

class GMessage {

private:
  uint8_t checksumme(uint8_t *sensordaten);

public:
  GMessage();
  void send();
  void accoustic_ALARM_OFF();
  void accoustic_ALARM_LOW_VOLTAGE();
  void checkLowVoltage(float voltage);
  void setMainVoltage(float amp);
  void setVoltage1(float volt);
  void setVoltage2(float volt);
  void setLipo1(float zelle);
  void setLipo2(float zelle);
  void setLipo3(float zelle);
  void setLipo4(float zelle);
  void setLipo5(float zelle);
  void setLipo6(float zelle);
  void setAmpere(float amp);
  void setMilliAmpere(uint32_t mA);
  void setAltitudeInMeters(uint16_t hoehe);
  void setClimbrate(float sr);
  void setClimbrate_M3(int srmmm);
  void setTemp1(int temp);
  void setTemp2(int temp);
  void setFuelPercent(uint8_t prozent);
  void setFuelMilliliters(uint16_t ml);
  void setRPM(uint32_t rpm);
};
#endif


